# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\eve\common\script\sys\eveProcessHealthSvc.py
import blue
import svc

class EveProcessHealthSvc(svc.processHealth):
    __guid__ = 'svc.eveProcessHealth'
    __replaceservice__ = 'processHealth'
    __servicename__ = 'eveProcessHealth'
    __displayname__ = 'Eve Process Health Service'

    def __init__(self, *args):
        svc.processHealth.__init__(self)
        self.columnNames += ('bytesReceived', 'bytesSent', 'packetsReceived', 'packetsSent')
        if boot.role == 'server':
            self.columnNames += ('dogmaLateness', 'maxModules', 'totalModules', 'sessionCount', 'solCount')
        if boot.role != 'client':
            self.columnNames += ('numEvents',)

    def LogDogma(self):
        if boot.role == 'server':
            maxModules = 0
            totalModules = 0
            avgModules = 0
            count = 0
            dogmaLag = [0]
            for bindparam, dogmaLocation in sm.GetService('dogmaIM').boundObjects.items():
                if not hasattr(dogmaLocation, 'effectTimerList'):
                    continue
                effectList = dogmaLocation.effectTimerList
                count += 1
                if effectList:
                    try:
                        dogmaLag.append(float(effectList[0][0] - blue.os.GetSimTime()) / float(const.SEC))
                    except KeyError:
                        pass

                if len(effectList) > maxModules:
                    maxModules = len(effectList)
                totalModules += len(effectList)

            mostLag = min(0, min(dogmaLag))
            self.logLines[-1].update({'solCount': count,
             'maxModules': maxModules,
             'totalModules': totalModules,
             'dogmaLateness': -1 * mostLag})

    def LogEventCount(self):
        if boot.role != 'client':
            counters = sm.GetService('eventLog').logEventCounter
            num = 0
            for k, v in counters.iteritems():
                num += v[1]

            self.logLines[-1].update({'numEvents': num})

    def DoOnceEvery10Secs(self):
        self.LogCpuMemNet()
        self.LogDogma()
        self.LogEventCount()